#include <stdio.h>
#include <mysql.h>
#include <unistd.h>
#include <sys/types.h>
#include <err.h>


int
main(int argc, char **argv)
{
	MYSQL *mysql;
	//const char *sock = "/var/dovecot/auth/mysql.sock";
	const char *sock = "/mysql.sock";
	const char *host = NULL;
	const char *user = "db_user";
	const char *pw = "db_pw";
	const char *db = "dbname";
	unsigned int port = 0;
	unsigned long flag = 0;
	uid_t	uid = 519;
	gid_t	gid = 519;
	int	i;

	printf("Connecting: host(%s), user(%s), pw(%s), db(%s),"
			" port(%u), sock(%s), flag(%lu)\n",
			host, user, pw, db, port, sock, flag);
	if (chroot("/var/dovecot/auth") != 0 || chdir("/") != 0)
		err(1,"chroot");
	if (setgroups(1, &gid) != 0)
		err(1,"setgroups");
	if (setegid(gid) != 0 || setgid(gid) != 0)
		err(1,"setegid");
	if (seteuid(gid) != 0 || setuid(gid) != 0)
		err(1,"seteuid");
	(void) setsid();

	mysql = mysql_init(NULL);
	if (mysql == NULL)
		errx(1, "Out of memory");

	i = mysql_real_connect(mysql, host, user, pw, db,
			port, sock, flag) == NULL;
	printf("i:(%i) %s\n", i, i ? mysql_error(mysql) : "Connected");

	return(0);
}
